clear all
randn('seed',0);
rand('seed',0);
%constant control and variable T
w=-2.5:0.001:2.5; 
f1=(-4*w.^2-w.^3+w.^4);
[Y2,I2]=min(f1);
fprintf('w opt %f\n',w(I2))

t=0.01;
g=exp(-w.^2/2/t);
F1=-log(conv(exp(-f1),g,'same'));
[Y1,I1]=min(F1);
fprintf('w opt for F1 %f\n',w(I1))

t=0.5;
g=exp(-w.^2/2/t);
F2=-log(conv(exp(-f1),g,'same'));
[Y3,I3]=min(F2);
fprintf('w opt for F2 %f\n',w(I3))


figure(1)
plot(w,f1,w,F1,w,F2);
legend('f','F (T=0.01)','F (T=0.5)')
xlabel('w')

print -depsc graph4a


figure(2)
t1=0.01;
t2=0.5;
eta=0.5;
m=500;
maxi=15;
ntries=41;
w_all=zeros(ntries,maxi);
ess_all=zeros(ntries,maxi);
v_all=zeros(ntries,maxi);
es_all=zeros(ntries,maxi);
u_all=zeros(ntries,maxi);
for j=1:ntries
	w=-2+0.1*(j-1);
	i=0;
	u=0;
    T=0.5;
    eta=0.1/T;
	for i=1:maxi
		u=(1-eta)*u;
		W=sqrt(T)*randn(1,m);
		x=w+u*T+W;
        f1=(-4*x.^2-x.^3+x.^4);
		S=f1 +0.5*T*u^2 +u*W;
		alpha=exp(-S);
		klad=alpha/sum(alpha);
		ess=1/(sum(klad.^2))*1/m;
		psi=mean(alpha);
        v= var(klad);
		u=u+1/T*mean(W.*alpha)/psi;
		w=w+eta*u*T;
        
        T=1/(1+exp(i-maxi*0.7));
        eta=0.1/T;
        
		w_all(j,i)=w;
        v_all(j,i)=v;
        u_all(j,i)=u;
		ess_all(j,i)=ess;
        es_all(j,i)=m/(1+m^2*v);
		J_all(j,i)=-log(psi);
        tall(i) = T;
	end;
end;
mean(w_all(:,maxi))
clf
%subplot(2,2,1)
plot(w_all')
xlabel('iteration');
ylabel('w')
print -depsc graph4b
%{
subplot(2,2,3)
plot(f_all')
xlabel('iteration');
ylabel('f')
wfinal=w_all(:,maxi);
subplot(2,2,4)
plot(J_all')
xlabel('iteration');
ylabel('F')
mean(wfinal)
std(wfinal)
ffinal=f(wfinal,b,phi);
mean(ffinal)
std(ffinal)
%}