clear all
randn('seed',0);
rand('seed',0);
%constant control and variable T


N=100;
dim = 2;
m=500;
maxi=150;
ntries=1;
w = zeros(dim,1);
x = zeros(dim,m);
w_all=zeros(dim,ntries,maxi);
ess_all=zeros(ntries,maxi);
v_all=zeros(ntries,maxi);
es_all=zeros(ntries,maxi);
u_all=zeros(dim,ntries,maxi);
noise=zeros(dim,m,N);
alp=ones(dim,1);
beta=5;
T=1;
eta=0.05;

for j=1:ntries,
	w=(-2.1-0.1*j)*ones(1,dim);
	i=0;
    u = zeros(dim,1);
    x = zeros(dim,m);     
	for i=1:maxi
        w_all(:,j,i)=w;
        dt= T/N;   
        W = sqrt(T)*randn(dim,m);
        x = w' + u*T + W;
        f1 = x(1,:).^4 -x(1,:).^3+ x(2,:).^4-4*x(1,:).*x(2,:)+1; 
       S_all = beta*f1+0.5*T*(u'*u)+u'*W;
       S_all = S_all- min(S_all);
       alpha=exp(-S_all);
       klad=alpha/sum(alpha);
  	   ess=1/(sum(klad.^2))*1/m;
       psi=mean(alpha,2);
       v= var(klad);
       u=u+1/T*mean(W.*alpha,2)/psi;
        
       w=w+eta*u';
       
       v_all(j,i)=v;
       u_all(:,j,i)=u;
	   ess_all(j,i)=ess;
       es_all(j,i)=m/(1+m^2*v);
       tall(i) = T;
	end;
end;
cd= mean(w_all(:,:,maxi),2)


%Langevin descent

N=m;
dt=T/N;
x_all=zeros(N,dim);
wall=zeros(dim,maxi);
w=[-2,-2];
for j=1:maxi
    x_all(1,:)=w+sqrt(0.5*dt/beta)*randn(1,dim);
    wall(:,j)=w;
    x=w;
    gg=0;
    for i=2:N
     dw=sqrt(0.5*dt/beta)*randn;
     E= grf1(x(1),x(2))-beta/T*(x-x_all(i-1,:));
     x=x -E*dt+dw;
     x_all(i,:)=x; 
    end;
    xm=mean(x_all);
    w=w - beta/T*(w-xm)*eta;
end;
ld = mean(wall,2)


%gradient descent

for j=1:ntries
	w=(-2.1-0.1*j)*ones(1,dim);
	i=0;
    v=zeros(1,dim);
	for i=1:maxi
       w_desc(:,j,i)=w;
       v = grf1(w(1),w(2));
	   w=w-eta*v;     
	end;
end;
gd = mean(w_desc(:,:,maxi),2)

ctr =reshape(w_all,[dim,maxi]);
x=squeeze(ctr(1,:));
y=squeeze(ctr(2,:));
z=1:1:maxi;
gds=reshape(w_desc,[dim,maxi]);
r=squeeze(gds(1,:));
s=squeeze(gds(2,:));
h=squeeze(wall(1,:));
k=squeeze(wall(1,:));


bas= -8:0.1:8;
[X,Y]=meshgrid(bas,bas);
Z=X.^4-X.^3+Y.^2-4*X.*Y+1;
[M,I] = min(Z(:));
[I_row, I_col] = ind2sub(size(Z),I);
a=g(bas(I_col),bas(I_row));
b=g(cd(1),cd(2));
c=g(gd(1),gd(2));
d=g(ld(1),ld(2));
minim = [bas(I_col),bas(I_row)]


fprintf('value of the min obtained through min finding in matlab %f\n',a)
fprintf('value of the min obtained through control descent %f\n',b)
fprintf('value of the min obtained through langevin extimate %f\n',d)
fprintf('value of the min obtained through gradient descent, with analitically computed gradient %f\n',c)


plot(x,y,'r')
hold on
plot(r,s,'m')
hold on
plot(h,k,'k')
hold on
plot(bas(I_col),bas(I_row),'b*')
contour(X,Y,Z)
hold off

print -depsc graph7